cellDoorOpened = false
walkinCellFinished = false
cellExitReached = false
exitReached = false
hangarReached = false
spaceShipReached = false
spaceShipEntered = false
playerInLock = false

randTime = 0
height = 29


function dist( x1,x2,x3, y1,y2,y3 )

return math.sqrt( (x1-y1)^2 + (x2-y2)^2 + (x3-y3)^2 )

end

function observeGuard()
guardX = guard:getAbsCoorX()
guardY = guard:getAbsCoorY()
guardZ = guard:getAbsCoorZ()

if dist( guardX,guardY,guardZ, 198.427155, 29, 243.656113 ) < 60 then
cellDoorOpened = true
end

end

function observePlayer()
playerX = Player:getAbsCoorX()
playerY = Player:getAbsCoorY()
playerZ = Player:getAbsCoorZ()

if dist( playerX,playerY,playerZ,161.76,49,358.87 ) < 60 then
playerInLock = true
end

end

walkProgrammed = false
exitProgrammed = false
function walkInCell(timestep)

if not walkProgrammed then
prisoner:walkTo( -66.454849, height, 62.363449)
prisoner:walkTo( -66.454849, height, 62.363449)
prisoner:walkTo( -63.214821, height, 62.429710)
prisoner:walkTo( -56.661182, height, 62.563740)
prisoner:walkTo( -46.779755, height, 62.765827)
prisoner:walkTo( -41.634224, height, 71.319214)
prisoner:walkTo( -38.168526, height, 79.655807)
prisoner:walkTo( -40.782196, height, 101.285233)
prisoner:walkTo( -47.722874, height, 114.314980)
prisoner:walkTo( -54.593349, height, 118.605423)
prisoner:walkTo( -62.802982, height, 117.947144)
prisoner:walkTo( -73.180130, height, 116.720863)
prisoner:walkTo( -85.028603, height, 114.952316)
prisoner:walkTo( -113.125824, height, 96.362946)
prisoner:walkTo( -118.218887, height, 87.702599)
prisoner:walkTo( -120.596275, height, 80.304184)
prisoner:walkTo( -114.928169, height, 68.971840)
prisoner:walkTo( -108.606766, height, 62.085098)
prisoner:walkTo( -90.078171, height, 59.558804)
prisoner:walkTo( -83.558510, height, 60.516567)
prisoner:walkTo( -71.352402, height, 63.920750)
walkProgrammed = true
end


if prisoner:finalGoalReached() and not cellDoorOpened then
   walkProgrammed = false
  end

if cellDoorOpened then

  if not exitProgrammed then
prisoner:walkTo( -61.875267, height, 158.254517)
prisoner:walkTo( -62.335995, height, 170.318756)
prisoner:walkTo( -62.358681, height, 179.232559)
prisoner:walkTo( -55.998741, height, 189.289749)
prisoner:walkTo( -49.237957, height, 195.076263)
prisoner:walkTo( -39.007496, height, 195.889221)
prisoner:walkTo( -24.234095, height, 195.547043)
prisoner:walkTo( -11.409116, height, 196.236069)
prisoner:walkTo( 2.545602, height, 196.805954)
prisoner:walkTo( 13.875313, height, 196.377563)
prisoner:walkTo( 28.379402, height, 195.829132)
prisoner:walkTo( 41.672989, height, 195.326477)
prisoner:walkTo( 57.125935, height, 194.742126)
prisoner:walkTo( 70.114609, height, 194.251007)
prisoner:walkTo( 81.857407, height, 193.806961)
prisoner:walkTo( 97.840607, height, 193.974030)
prisoner:walkTo( 107.569641, height, 196.299652)
prisoner:walkTo( 120.975266, height, 202.754532)
prisoner:walkTo( 129.063812, height, 207.099640)
prisoner:walkTo( 140.468765, height, 214.389191)
prisoner:walkTo( 145.902267, height, 224.194229)
prisoner:walkTo( 148.106079, height, 233.095215)
prisoner:walkTo( 150.907532, height, 244.410049)
prisoner:walkTo( 153.191757, height, 253.635788)
prisoner:walkTo( 153.191757, height, 253.635788)
   exitProgrammed = true
  end

  if prisoner:finalGoalReached() then
   return true
  end

 end 

return false

end


return false

end


gotoExitProgrammed = false
function goToExit(timestep)
-- do not forget to make him wait until the player triggeres the trip to the hangar
if not gotoExitProgrammed and playerInLock then

gotoExitProgrammed = true
end

if prisoner:finalGoalReached() then
   return true
end

return false
end

hangarRouteProgrammed = false
function goToHangar(timestep)

if not hangarRouteProgrammed then

hangarRouteProgrammed = true
end

if prisoner:finalGoalReached() then
   return true
end

return false

end

spaceshipRouteProgrammed = false
function goToSpaceship(timestep)

if not spaceshipRouteProgrammed then


spaceshipRouteProgrammed = true
end

if prisoner:finalGoalReached() then
   return true
end

return false

end


function enterSpaceship(timestep)

return false
end



function tick(timestep)

 observeGuard()
 observePlayer()


if not cellDoorOpend then
walkinCellFinished = walkInCell(timestep)
end

if walkinCellFinished and not exitReached then
exitReached = goToExit(timestep)
end

if exitReached and not hangarReached then
hangarReached = goToHangar(timestep)
end

if hangarReached and not spaceShipReached then 
spaceShipReached = goToSpaceship(timestep)
end

if spaceShipReached and not spaceShipEntered then
spaceShipEntered = enterSpaceship(timestep)
end

if spaceShipEntered then
return true
end

return false
end